/* pipe-sim(+vector) ver.4.0 [94/05/30-06/15] */
/* 		     ver.4.0a[94/06/16-06/] */
/* multiple jump arbitration unit */

#include "defines.h"
#include "latches.h"
#include "cmnvar.h"
#include "opcode.h"
#include "regdef.h"
#include "register_set.h"

void jumparb()
{
	int i,ip;

	for (ip = 0 ; ip < NIP ; ip++) {
	    if (jumploadpc_id[ip]==TRUE) {
		/* set jumploadpc flag TRUE */
		jumploadpc[ip] = TRUE;
		/* Jump load PC priority = ip0>ip1>ip2>ip3... */
		for (i = ip+1 ; i < NIP ; i++) {
		    if (jumploadpc_id[i] == TRUE) {
			/* disable jumploadpc_id[i] */
			jumploadpc_id[i] = FALSE;
			/* jump taken flag clear */
			ALUlatch[i].jump_taken = FALSE;
		    }
		}
		/* id stage jump has higher priority */
		/* than alu stage comp&jump */
		for (i = 0 ; i < NIP ; i++) {
		    if (jumploadpc_alu[i] == TRUE) {
			/* disable jumploadpc_alu[i] */
			jumploadpc_alu[i] = FALSE;
		    }
		}
	    }
	}
	for (ip = 0 ; ip < NIP ; ip++) {
	    if (jumploadpc_alu[ip]==TRUE) {
		/* set jumploadpc flag TRUE */
		jumploadpc[ip] = TRUE;
		/* Jump load PC priority = ip0>ip1>ip2>ip3... */
		for (i = ip+1 ; i < NIP ; i++) {
		    if (jumploadpc_alu[i] == TRUE) {
			/* disable jumploadpc_id[i] */
			jumploadpc_alu[i] = FALSE;
		    }
		}
	    }
	}
}
