/* pipe-sim(+vector) ver.4.0 [94/05/30-06/15] */
/* 		     ver.4.3c[96/08/9] */
/* load unit */

#include "defines.h"
#include "latches.h"
#include "cmnvar.h"
#include "opcode.h"
#include "memwait.h"

static int address[NIP];

static char lu0_status[NIP][SSLEN];
static char lu1_status[NIP][SSLEN];

char *loadu0(ip)
int	ip;
{
	address[ip] = loadaddr[ip];

	sprintf(lu0_status[ip],"loadaddr = 0x%X(%d)",address[ip],address[ip]);
	return(lu0_status[ip]);
}

char *loadu1(ip)
int	ip;
{
	if (loadflag[ip] == TRUE) {
	    if ((address[ip] < 0)||(address[ip] >= MEMSIZE)) {
		error("bus error","loadunit phase 1",ip);
		loadflag[ip] = FALSE; /* irregal addr. access */
		sprintf(lu1_status[ip],"buserror at addr. 0x%X(%d)",address[ip],address[ip]);
	    } else {
		loaddata[ip] = memory[address[ip]];

		/* memory access wait cycle (read) */
		readmemwait[ip] = 2;
		/*		  ^ change here! */

		loadflag[ip] = FALSE;
		sprintf(lu1_status[ip],"loaddata = %d(%f)",
			loaddata[ip].i,loaddata[ip].f);
	    }
	} else { /* loadflag[ip] is FALSE */
	    sprintf(lu1_status[ip],"loadflag is FALSE");
	}

	return(lu1_status[ip]);
}
