/***
 ***    ps3v ver.3.5a-R1.0 [92/Oct/25] by kata.
 ***    ps4v ver.4.0	   [94/May/30-Jun/15] by kata.
 ***         ver.4.0a	   [94/Jun/16-Jun/] by kata.
 ***         ver.4.1 	   [94/Dec/3-] by kata.
 ***         ver.4.2 	   [94/Dec/19-] by kata.
 ***
 ***    clear all register procedure.
 ***
 ***/

#include <stdio.h>
#include <stdlib.h>
#include "defines.h"
#include "cmnvar.h"
#include "regdef.h"
#include "register_set.h"

clear_reg()
{
	int  i;

	for ( i = 0 ; i < SPECIALREGS ; i++ ) {
		specialregfile[i].i = 0;
	}

	for ( i = 0 ; i < GLOBAL ; i++ ) {
		global_register[i].i = 0;
	}

#ifdef BANKED
	for ( i = 0 ; i < LOCAL ; i++ ) {
		banked_registers_0[i].i = 0;
		banked_registers_1[i].i = 0;
		banked_registers_2[i].i = 0;
		banked_registers_3[i].i = 0;
	}

	for ( i = 0 ; i < OVERLAP ; i++ ) {
		overlap_registers_0[i].i = 0;
		overlap_registers_1[i].i = 0;
		overlap_registers_2[i].i = 0;
		overlap_registers_3[i].i = 0;
	}
#endif

	global_write_count_wb = 0 ;
	global_write_count_fwb = 0 ;

#ifdef BANKED
	bankreg0_write_count_wb = 0 ;
	bankreg1_write_count_wb = 0 ;
	bankreg2_write_count_wb = 0 ;
	bankreg3_write_count_wb = 0 ;

	bankreg0_write_count_fwb = 0 ;
	bankreg1_write_count_fwb = 0 ;
	bankreg2_write_count_fwb = 0 ;
	bankreg3_write_count_fwb = 0 ;

	overlap0_write_count_wb = 0 ;
	overlap1_write_count_wb = 0 ;
	overlap2_write_count_wb = 0 ;
	overlap3_write_count_wb = 0 ;

	overlap0_write_count_fwb = 0 ;
	overlap1_write_count_fwb = 0 ;
	overlap2_write_count_fwb = 0 ;
	overlap3_write_count_fwb = 0 ;
#endif

	write_collision = 0 ;

}

clear_write_count()
{
	global_write_count_wb = 0 ;
	global_write_count_fwb = 0 ;

#ifdef BANKED
	bankreg0_write_count_wb = 0 ;
	bankreg1_write_count_wb = 0 ;
	bankreg2_write_count_wb = 0 ;
	bankreg3_write_count_wb = 0 ;

	bankreg0_write_count_fwb = 0 ;
	bankreg1_write_count_fwb = 0 ;
	bankreg2_write_count_fwb = 0 ;
	bankreg3_write_count_fwb = 0 ;

	overlap0_write_count_wb = 0 ;
	overlap1_write_count_wb = 0 ;
	overlap2_write_count_wb = 0 ;
	overlap3_write_count_wb = 0 ;

	overlap0_write_count_fwb = 0 ;
	overlap1_write_count_fwb = 0 ;
	overlap2_write_count_fwb = 0 ;
	overlap3_write_count_fwb = 0 ;
#endif
}	
