/* pipe-sim(+vector) ver.3.0 [92/05/28-7/29] */
/* 		     ver.3.5 [92/12/14] */
/* pipe-sim(+vector) ver.4.0 [94/05/30-6/15] */
/* dump memory procedure */

#include <stdio.h>

#include "defines.h"
#include "latches.h"
#include "cmnvar.h"
#include "opcode.h"

int dumpmem(dumpfile,start,end)
char	*dumpfile;	/* dump filename */
int	start,end;	/* start&end address */
{
	int	i;
	FILE	*fp;
	
	if (start>end) return FALSE;

	if ((fp = fopen(dumpfile,"w")) == NULL) {
	    return (FALSE);
	}

	for (i = start ; i <= end ; i+=3) {
		fprintf(fp,"%08X: ",i);
		fprintf(fp,"%11d(%11.5f) ",memory[i].i,memory[i].f);
		fprintf(fp,"%11d(%11.5f) ",memory[i+1].i,memory[i+1].f);
		fprintf(fp,"%11d(%11.5f) ",memory[i+2].i,memory[i+2].f);
		fprintf(fp,"\n");
	}
	fclose(fp);
	return (TRUE);
}
