/* pipe-sim(+vector) ver.3.0 [92/05/28-7/29] */
/* 		     ver.3.5a-R1.0 [93/10/25] */
/*					*/
/* 		     ver.4.0 [94/5/30-6/15] */
/* 		     ver.4.0a[94/6/16-6/] */
/* 		     ver.4.3 [94/12/26-95/01/20] */
/* define external functions            */

extern char *ifetch0(void),*ifetch1(void);
extern char *decode0(int ip),*decode1(int ip);
extern char *alu_0(int ip),*alu_1(int ip);
extern char *mem_0(int ip),*mem_1(int ip);
extern char *wb_0(int ip),*wb_1(int ip);
extern char *fwb_0(int ip),*fwb_1(int ip);
extern char *loadu0(int ip),*loadu1(int ip);
extern char *storeu0(int ip),*storeu1(int ip);
extern char *vlu0(int ip),*vlu1(int ip);
extern char *vsu0(int ip),*vsu1(int ip);
extern void pm0(int ip),pm1(int ip);
extern void faspinit(void),fmpinit(void),fdpinit(void),vilpinit(void),cninit(void);
extern char *fasp_in(int fp),*fmp_in(int fp),*fdp_in(int fp),*vilp_in(int ilp);
extern void fasp_out(int fp),fmp_out(int fp),fdp_out(int fp),vilp_out(int ilp);
extern char *faspctl0(int fp),*faspctl1(int fp);
extern char *fmpctl0(int fp),*fmpctl1(int fp);
extern char *fdpctl0(int fp),*fdpctl1(int fp);
extern char *vilpctl0(int ilp),*vilpctl1(int ilp);
extern char *cn_in(int cn),*cn_out(int cn);
extern void startfasp(int ip, int pipeop, int src1, int src2, int dstn, int chain, int vmr);
extern void startfmp(int ip, int pipeop, int src1, int src2, int dstn, int chain, int vmr);
extern void startfdp(int ip, int pipeop, int src1, int src2, int dstn, int chain, int vmr);
extern void startvilp(int ip, int pipeop, int src1, int src2, word scalarsrc, int dstn, int chain, int vmr);
extern char *printinst(decoded_inst inst, int ip);
extern int regmatch(int ip1, int reg1, int ip2, int reg2);
extern word reg_read(int ip, int no),reg_read_nochk(int ip, int no);
extern word linear_reg_read_nochk(int no);
extern int reg_write_wb(int ip, int no, word value);
extern int reg_write_fwb(int ip, int no, word value);
extern int reg_write_nochk(int ip, int no, word value);
extern void vectorcount(void),clear_vectorcount(void);
