/* pipe-sim(+vector) ver.4.0 [94/05/30-06/15] */
/* define instruction pipe constants     */
/* for MP4(Multi-Pipe vilw 4-instrctions)*/

/* NIP = Number of Instruction Pipes */
#define NIP	4
/* PADSFT = ProgADdrress ShiFT value */
#define PADSFT	2
/* PADMASK = ProgADdrress MASK value */
#define PADMASK	~3

/* NFASP = Number of Floating Add/Sub Pipes */
#define NFASP	(NIP/2)
/* NFMP = Number of Floating Mult Pipes */
#define NFMP	(NIP/2)
/* NFDP = Number of Floating Div Pipes */
#define NFDP	(NIP/2)
/* NVILP = Number of Vector Integer/Logical Pipes */
#define NVILP	(NIP/2)
