/***
 ***    ps3v ver.3.5a-R1.0 [92/Oct/25] by kata.
 ***    ps3v ver.3.5a-R1.0a [92/Oct/26] by kata.
 ***
 ***    ps4v ver.4.0 [94/May/30-Jun/15] by kata.
 ***         ver.4.0a[94/Jun/16-Jun/] by kata.
 ***         ver.4.2 [94/Dec/19-] by kata.
 ***
 ***    special reg. access functions.
 ***
 ***/

#include <stdio.h>
#include <stdlib.h>
#include "defines.h"
#include "cmnvar.h"
#include "extfunc.h"
#include "regdef.h"
#include "register_set.h"
/* register number is from 0 to 127;
   if global registers are 4, their number is from 0 to 3.
   if global registers are 8, their number is from 0 to 8.
*/

/* set  condition code to reg2 */
/* condition code = FRAGREG(reg2) bit0-7 */
/* bit0(LSB)-1=ip0,bit2-3=ip1,bit4-5=ip2,bit6-7=ip3 */
/* pn = Instruction pipe number(0~3) */

setCC(pn,value)
int pn,value;
{
	word flag;

	flag.i=((reg_read_nochk(pn,N_FR).i&(~(3<<((pn)<<1))))|(((value)&3)<<((pn)<<1)));
	reg_write_nochk(pn,N_FR,flag);
}

/* set ZERO-REGISTER (do nothing) */
setZEROREG(pn,value)
int pn,value;
{
}

/* set PC */
setPC(pn,value)
int	pn,value;
{
	word v;

	v.i = value;
	reg_write_nochk(pn,N_PC,value);
}
