/* ps4v/asm4v special register defines */
/* for asm4v ver.1.1 [94/Dec/9] */

/* for ps4v ver.4.2 [94/Dec/19] */
/* 	    ver.4.3 [94/Dec/26-95/Jan/20] */

#define SPECIALBASE 128 /* Special register = 128 ~ 255 */
#define SPECIALREGS (REGSIZE-SPECIALBASE)

#define N_SZR 128	/* Number of Special Zero Register */
#define N_PC 129	/* Number of Program Counter */
#define N_FR 130	/* Number of Flag Register */
#define N_SP 131	/* Number of Stack Pointer */
#define N_FP 132	/* Number of Frame Pointer */
#define N_LR 133	/* Number of Link Register */
#define N_PSL 134	/* Number of Program Segment Low */
#define N_PSH 135	/* Number of Program Segment High */

#define PCREGNO N_PC
#define LINKREG N_LR

#define N_VACR 136	/* Number of Vector Add/Sub Count Reg. */
#define N_VMCR 138	/* Number of Vector Mult Count Reg. */
#define N_VDCR 140	/* Number of Vector Div Count Reg. */
#define N_VICR 142	/* Number of Vector Int-ALU Count Reg. */

#define N_VLCR 144	/* Number of Vector Load Count Reg. */
#define N_VSCR 148	/* Number of Vector Store Count Reg. */
