/* pipe-sim(+vector) ver.4.0 [94/05/30-06/15] */
/* 		     ver.4.3 [94/12/26-95/01/20] */
/*                   ver.4.3c[96/08/9] */
/* store unit */

#include "defines.h"
#include "latches.h"
#include "cmnvar.h"
#include "opcode.h"
#include "memwait.h"

static int address[NIP];
static word data[NIP];

static char su0_status[NIP][SSLEN];
static char su1_status[NIP][SSLEN];

char *storeu0(ip)
int	ip;
{
	address[ip] = storeaddr[ip];
	data[ip] = storedata[ip];

	sprintf(su0_status[ip],"storeaddr = 0x%X(%d), storedata = %d(%f)",
		address[ip],address[ip],data[ip].i,data[ip].f);
	return(su0_status[ip]);
}

char *storeu1(ip)
int	ip;
{
	if (storeflag[ip] == TRUE) {
	    if ((address[ip] < 0)||(address[ip] >= MEMSIZE)) {
		error("bus error","storeunit phase 1",ip);
		storeflag[ip] = FALSE;
                sprintf(su1_status[ip],
			"buserror at addr. 0x%X(%d)",address[ip],address[ip]);
	    } else if ((address[ip] >= SPECIALREG(N_PSL).i)&&
		       (address[ip] < SPECIALREG(N_PSH).i)) {
		error("segmentation fault","storeunit phase 1",ip);
		storeflag[ip] = FALSE;
                sprintf(su1_status[ip],
			"segmentation fault at addr. 0x%X(%d)",address[ip],address[ip]);
	    } else {
		memory[address[ip]] = data[ip];

                /* memory access wait cycle (write) */
                writememwait[ip] = 2;
                /*                 ^ change here! */

		storeflag[ip] = FALSE;
                sprintf(su1_status[ip],"store execute(storeflag is TRUE)");
	    }
	} else { /* storeflag[ip] is FALSE */
            sprintf(su1_status[ip],"storeflag is FALSE");
        }

        return(su1_status[ip]);
}
